#!/usr/local/bin/perl


#4 aug 94 hwb changed to specs needed:
#	1.  take out first col of latrex table
#	2. split up by direction e.g., nntpdst nntpsrc
#	3. add other line so total = 100%

# collapse {prot/}sport/dport attributions.
# from mpacct output file to a table of 
# the top ten flows [right now] and then
# statistics on percent of flows, packets,
# bytes, and flowsecs attributed to the top
# n [ten] [by packet] protocols [port pairs]

# Syntax:  mp2ppcoll.pl fname {limit for entries} {start time} {end time}

# Input:
# New 0.031922	807dfd88:8afd1f02	0	0	0	53:53
# Acctclr: 16.046394 807dfd88:8afd1f02	1	101	0	53:53

$|=1;
$fname = $ARGV[0];
$arg2  = $ARGV[1];
$stime = $ARGV[2];
$etime = $ARGV[3];
if($etime < 1){$etime=9999999;}

$portthreshold   =  3;		# Threshold for port references in pairings
$minpackets      =  5;		# minimum number of packets per flow
$printcount      = 25;		# print limit default if no second argument

if($arg2 > 0) {$printcount = $arg2;}

printf"SDSC-ANR:MP2PPCOLL on file '%s' from %d to %d seconds\n",
      $fname,$stime,$etime;

open(infile,"$fname") || die;
while(<infile>){
 ($txt,$time,$apair,$p,$b,$d,$ports,@rest)=split(' ',$_);
 if($txt =~ "A"){
  if($time >= $etime){goto out;}
  if($time >= $stime){
   ($prot,$sport,$dport)=split(':',$ports);
   $count++;
   $tp=$tp+$p;
   $tb=$tb+$b;
   $td=$td+$d;
# protocols
   $prc{$prot}++;
   $prp{$prot} = $prp{$prot} + $p;
   $prb{$prot} = $prb{$prot} + $b;
   $prd{$prot} = $prd{$prot} + $d;
# ports for prot 6 and 17
   if($prot == 6 || $prot == 17) {
    $poc{$prot,$sport,$dport}++;
    $pop{$prot,$sport,$dport} = $pop{$prot,$sport,$dport} + $p;
    $pob{$prot,$sport,$dport} = $pob{$prot,$sport,$dport} + $b;
    $pod{$prot,$sport,$dport} = $pod{$prot,$sport,$dport} + $d;
   }
  }
 }
}
close(infile);
out:;

printf"\n\n\n";
printf"Total triplets: %d\n",$count;
printf"Total packets:  %d\n",$tp;
printf"Total bytes:    %d\n",$tb;
printf"Total duration: %d\n",$td;

# Analyze Protocols.
printf"\n\n\nItemized by protocols:\n";
printf"Prot  Packets  Fract       Bytes Fract   Duration  Count\n";
printf"==== ======== ======= ========== ======= ======== =======\n";
foreach $key ( sort numerically ( keys %prp)) {
 printf"%4d %8d %.5f %10d %.5f %8d %7d\n",
	$key,$prp{$key},$prp{$key}/$tp,$prb{$key},$prb{$key}/$tb,
	$prd{$key},$prc{$key};
}

# Analyze ports.
printf"\n\n\nItemized by TCP/UDP ports:\n";
# Collapse < 1000 ports.
foreach $key ( sort numerically ( keys %pop)) {
 $portcount{$prot}++;
 ($prot,$sport,$dport) = split( $;, $key ) ;
 if(($sport < 1000) && ($dport >= 1000)) {$dport = ' ';}
 if(($dport < 1000) && ($sport >= 1000)) {$sport = ' ';}
 $poc2{$prot,$sport,$dport} = $poc2{$prot,$sport,$dport} + $poc{$key};
 $pop2{$prot,$sport,$dport} = $pop2{$prot,$sport,$dport} + $pop{$key};
 $pob2{$prot,$sport,$dport} = $pob2{$prot,$sport,$dport} + $pob{$key};
 $pod2{$prot,$sport,$dport} = $pod2{$prot,$sport,$dport} + $pod{$key};
}
printf"Total number of unique port references: %7d (for TCP) %7d (for UDP)\n",
	$portcount{6},$portcount{17};

# Count references.
foreach $key ( sort numerically ( keys %pop2)) {
 ($prot,$sport,$dport) = split( $;, $key ) ;
 $portcount2{$prot}++;
 if($sport >= 1000) {
  $portref{$sport}++;
  $portref{$dport}++;
 } else {
  $lt1000++;
 }
}
printf"Port references after <1000 collapse:   %7d (for TCP) %7d (for UDP)\n",
	$portcount2{6},$portcount2{17};
printf"%d ports used in below 1000 range \n\n",$lt1000;

# Display ports with excessive references in pairings.
printf"Find multiple (%d) port references for port pairs:\n\n",$portthreshold;
foreach $key ( sort prefnumerically ( keys %portref)) {
 if($portref{$key} >= $portthreshold) {
  if($mulcount++ < $printcount) {
   printf"Port %5d is found paired %6d times.\n",$key,$portref{$key};
  }
  $expcount++;
  $exprefcount = $exprefcount + $portref{$key};
 }
}
printf"     =====                 ======\n";
printf"For  %5d ports and       %6d references\n",$expcount,$exprefcount;

# Collapse further
printf"\nCollapsing with the added information\n";
foreach $key ( sort numerically ( keys %pop2)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 if(($portref{$sport} >= $portthreshold)&&($portref{$dport} < $portthreshold))
     {$dport = ' ';}
 if(($portref{$dport} >= $portthreshold)&&($portref{$sport} < $portthreshold))
     {$sport = ' ';}
 $poc3{$prot,$sport,$dport} = $poc3{$prot,$sport,$dport} + $poc2{$key};
 $pop3{$prot,$sport,$dport} = $pop3{$prot,$sport,$dport} + $pop2{$key};
 $pob3{$prot,$sport,$dport} = $pob3{$prot,$sport,$dport} + $pob2{$key};
 $pod3{$prot,$sport,$dport} = $pod3{$prot,$sport,$dport} + $pod2{$key};
}

# Print remainder
open(outfile,">appl.volume.$fname.$stime.$etime.new") || die;

printf"Detailed information sorted by traffic volume (bytes):\n\n";
printf"Prt SPort DPort kPkts P-Fract  kByt   B-Fract Size  Duratn D-Fract Count C-Fract\n\n";
foreach $key ( sort pob3numerically ( keys %pob3)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 $brank{$key} = ++$brankc;
 if($pop3{$key} >= $minpackets) {
  if($bmulcount++ < $printcount) {
   printf"%3d %5d %5d %5d %.3f   %7d %.3f   %4d %7d %.3f %6d %.3f\n",
	$prot,$sport+0,$dport+0,
        $pop3{$key}/1000,$pop3{$key}/$tp,$pob3{$key}/1000,$pob3{$key}/$tb,
        $pob3{$key}/$pop3{$key},
	$pod3{$key},$pod3{$key}/$td,$poc3{$key},$poc3{$key}/$count;
  }
  $atbfract=$atbfract+($pob3{$key}/$tb);
  printf outfile "%d\t%d:%d:%d\t%s\t%.6f\t%.6f\n",
   $applvcount++,$prot,$sport+0,$dport+0,$pob3{$key},$pob3{$key}/$tb,$atbfract;
  $portcount3++; 
 }
}

close(outfile);

printf"\n%d remaining port pair references were found\n",$portcount3;

#sorted by payload
printf"\nSorted by reference count:\n";
printf"Prt SPort DPort kPkts P-Fract  kByt   B-Fract Size  Duratn D-Fract Count C-Fract\n\n";
foreach $key ( sort poc3numerically ( keys %poc3)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 $crank{$key} = ++$crankc;
 if($pop3{$key} >= $minpackets) {
  if($cmulcount++ < $printcount) {
   printf"%3d %5d %5d %5d %.3f   %7d %.3f   %4d %7d %.3f %6d %.3f\n",
	$prot,$sport+0,$dport+0,
        $pop3{$key}/1000,$pop3{$key}/$tp,$pob3{$key}/1000,$pob3{$key}/$tb,
        $pob3{$key}/$pop3{$key},
	$pod3{$key},$pod3{$key}/$td,$poc3{$key},$poc3{$key}/$count;
  }
 }
}

#sort by packets
foreach $key ( sort pop3numerically ( keys %pop3)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 $prank{$key} = ++$prankc;
}

#sort by duration
foreach $key ( sort pod3numerically ( keys %pod3)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 $drank{$key} = ++$drankc;
}

# output ranks
printf"\nSorted by flow frequency and displaying ranks\n";
printf"Prt SPort DPort flow pkts byts secs\t|\tave-pkt\tave-byt\tave-size\n\n";
foreach $key ( sort cranknumerically ( keys %crank)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 if($rmulcount++ < $printcount) {
  printf"%3d %5d %5d %4d %4d %4d %4d\t|\t%d\t%d\t%.0f\n",
   $prot,$sport+0,$dport+0,$crank{$key},$prank{$key},$brank{$key},$drank{$key},
   $pop3{$key}/$poc3{$key},$pob3{$key}/$poc3{$key},
   ($pob3{$key}/$poc3{$key})/($pop3{$key}/$poc3{$key});
 }
}

# printf to appl.latex.new file
open(outfile,">appl.latex.$fname.$stime.$etime.new") || die;

printf outfile "\\begin{footnotesize}\n";
printf outfile "\\begin{table*}\n";
printf outfile "\\caption{\\label{fpb-sort} Proportion of flows, bytes, packets, and flow-seconds attributed to major protocols ($fname)}\n";
printf outfile "\\begin{center}\n";
printf outfile "\\begin{tabular}{||l||r|r|r|r||r|r|r|r||r|r|r|r||} \\hline\n";
printf outfile "service & \\multicolumn{4}{|c|}{number} & \\multicolumn{4}{|c|}{total} & \\multicolumn{4}{|c|}{rank} \\\\ \\hline\n";

printf outfile "{\\bf totals:} & %d & %.1f & %d & %d & & & & & & & & \\\\ \\hline\n",$count,$tp/1000,$tb/1000,$td;
printf outfile " & flows & kpackets & kbytes & flowsecs & fl & pk & bt & fs & fl & pk & bt & fs \\\\ \\\hline\n";

foreach $key ( sort cranknumerically ( keys %crank)) {
 if($platexcount++ < $printcount) {
  ($prot,$sport, $dport) = split( $;, $key ) ;
  printf outfile "%d:%d:%d & %d & %.1f & %.1f & %d & %.1f & %.1f & %.1f & %.1f & %d & %d & %d & %d \\\\ \\hline\n",
   $prot,$sport+0,$dport+0,
   $poc3{$key},$pop3{$key}/1000,$pob3{$key}/1000,$pod3{$key},
   ($poc3{$key}/$count)*100,($pop3{$key}/$tp)*100,
   ($pob3{$key}/$tb)*100,($pod3{$key}/$td)*100,
   $crank{$key},$prank{$key},$brank{$key},$drank{$key};
   $acf=$acf+$poc3{$key};
   $acp=$acp+$pop3{$key};
   $acb=$acb+$pob3{$key};
   $acd=$acd+$pod3{$key};
   $acfp=$acfp+($poc3{$key}/$count)*100;
   $acpp=$acpp+($pop3{$key}/$tp)*100;
   $acbp=$acbp+($pob3{$key}/$tb)*100;
   $acdp=$acdp+($pod3{$key}/$td)*100;
 }
}
printf outfile " other & %d & %.1f & %.1f & %d & %.1f & %.1f & %.1f & %.1f & NA & NA & NA & NA\\\\ \\\hline\n",
    $count-$acf,($tp/1000)-($acp/1000),
    ($tb/1000)-($acb/1000),$td-$acd,
    100-$acfp,100-$acpp,100-$acbp,100-$acdp;
printf outfile "\\end{tabular}\n\\end{center}\n";
printf outfile "\\end{table\*}\n\\end{footnotesize}\n";
close(outfile);

# printf to appl.triplets.new file
open(outfile,">appl.triplets.$fname.$stime.$etime.new") || die;
foreach $key ( sort poc3numerically ( keys %poc3)) {
 ($prot,$sport, $dport) = split( $;, $key ) ;
 if($pop3{$key} >= $minpackets) {
  printf outfile "%d:%d:%d\n",$prot,$sport+0,$dport+0;
 }
}
close(outfile);

sub numerically      { $a           <=> $b          ;}
sub prefnumerically  { $portref{$b} <=> $portref{$a};}
sub pob3numerically  { $pob3{$b}    <=> $pob3{$a}   ;}
sub poc3numerically  { $poc3{$b}    <=> $poc3{$a}   ;}
sub pod3numerically  { $pod3{$b}    <=> $pod3{$a}   ;}
sub pop3numerically  { $pop3{$b}    <=> $pop3{$a}   ;}
sub cranknumerically { $crank{$a}   <=> $crank{$b}  ;}
